##!/usr/bin/env python
## -*- coding: utf-8 -*-
##       level_end.py
##
##       Copyright 2008 Gordon Allott <gordallott@gmail.com>
##
##       This program is free software; you can redistribute it and/or modify
##       it under the terms of the GNU General Public License as published by
##       the Free Software Foundation; either version 3 of the License, or
##       (at your option) any later version.
##
##       This program is distributed in the hope that it will be useful,
##       but WITHOUT ANY WARRANTY; without even the implied warranty of
##       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##       GNU General Public License for more details.
##
##       You should have received a copy of the GNU General Public License
##       along with this program; if not, write to the Free Software
##       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
##       MA 02110-1301, USA.
##
##       #


#import pygame
#from pygame.locals import *

#import gamelib.data
#import gamelib.render
#import gamelib.world.gameworld
#from gamelib.world.gameworld import hex_to_gl
#from gamelib.world.props import *
#from gamelib.world.actors import *
#import gamelib.instance
#from gamelib.util import hex_to_gl

#from scene import *


#class level_end(Scene):

    #level_geom = 'levels/level_end.svg'

    #def __init__(self, *args, **kwargs):
        #Scene.__init__(self, *args, **kwargs)
        #self.stop_scene = False

        #self.game_world = gamelib.world.gameworld.world(self.render)
        #self.game_world.bg_gradient = (hex_to_gl('#000000'), hex_to_gl('#444444'))

        #gamelib.instance.instance.audio.play_music('Infados.ogg')

        ## add an actor
        #self.player = self.game_world.add_actor(actor_object=Player, position=(0.0, 3.0))


        #self.input.add_key(K_a, self.cb_walk, repeating=True)
        #self.input.add_key(K_d, self.cb_walk, repeating=True)
        #self.input.add_key(K_w, self.cb_jump, repeating=True)

        #self.input.add_key(K_BACKSPACE, self.cb_skip)


        #self.build_geoms(self.game_world, 'levels/level_end.svg')


        ##layer = self.game_world.create_layer(pos=-10, relative_movement=(0.5, 0.8))
        ##layer.add_graphic('bg1.png', tex_size=(10.0, 5.0), height=5.0, y_position=0.0)

        ##layer = self.game_world.create_layer(pos=-5, relative_movement=(0.25, 0.8))
        ##layer.add_graphic('clouds.png', tex_size=(10.0, 10.0), height=20.0, y_position=8)

        ### add a light i guess
        ##light = self.game_world.add_light()

        #self.game_world.bg_gradient = (hex_to_gl('#623166'), hex_to_gl('#36274b'))





    #def step(self):
        #pos = self.player.get_position()
        #self.render.set_screen_pos(-pos[0], -pos[1])
        #self.render.set_screen_zoom(1.5)
        #self.render.set_screen()

        #self.game_world.step()
        #self.game_world.draw()



        #self.render.reset()

    #def cb_skip(self, key):
        #self.stop_scene = True



    #def cb_walk(self, key):

        #if key == K_a:
            #self.player.go_left()
        #if key == K_d:
            #self.player.go_right()

    #def cb_jump(self, key):
        #self.player.jump()

#!/usr/bin/env python
# -*- coding: utf-8 -*-
#       level_one.py
#
#       Copyright 2008 Gordon Allott <gordallott@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 3 of the License, or
#       (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.
#
#


import pygame
from pygame.locals import *

import gamelib.data
import gamelib.render
import gamelib.world.gameworld
from gamelib.world.gameworld import hex_to_gl
from gamelib.world.props import *
from gamelib.world.actors import *
import gamelib.instance
from gamelib.timeline import Timeline, time_now, time_start
from gamelib.util import cosine_interpolate, linear_interpolate
from scene import *
from OpenGL.GL import *
import random

class yay_boxes:

    def __init__(self, x_pos, y_pos, bottom_pos, sprite):
        self.x = x_pos
        self.y = y_pos

        self.y_vel = 9.8

        self.bottom = bottom_pos
        self.sprite = sprite
        self.rot = random.randrange(0.0, 360.0)

    def step(self, grav=0.5, speed=0.0):
        if self.y < self.bottom:
            self.y_vel = grav * 4.0

        self.y += self.y_vel
        self.y_vel *= 0.9
        self.y -= grav

        self.rot += (0.6 * (self.y - self.bottom))

    def draw(self):
        self.sprite.position = (self.x, self.y)
        self.sprite.rotate = (0.0, 0.0, self.rot)
        self.sprite.draw()


class final(Scene):

    level_geom = 'levels/final.svg'

    fade_colora1 = hex_to_gl('#c34658')
    fade_colorb1 = hex_to_gl('#4b0047')

    fade_colora2 = hex_to_gl('#831f4f')
    fade_colorb2 = hex_to_gl('#280026')

    def __init__(self, *args, **kwargs):
        Scene.__init__(self, *args, **kwargs)
        self.timeline = Timeline()
        gamelib.instance.instance.audio.play_music('DD Groove.ogg')

        self.start_level()

    def start_level(self):
        self.fade_value = 0.0
        self.fade_blend = 'addictive'
        self.do_fade = False
        gamelib.instance.instance.audio.stop_all()

        self.do_reset = False

        self.stop_scene = False
        self.game_world = gamelib.world.gameworld.world(self.render)


        # add an actor
        self.player = self.game_world.add_actor(actor_object=Player, position=(0.0, 10.0 + 1.27*0.5))

        #self.set_keys()

        self.build_geoms(self.game_world, 'levels/final.svg')

        layer = self.game_world.create_layer(pos=-5, relative_movement=(0.25, 0.1))
        layer.add_graphic('stars.png', tex_size=(5.0, 2.5), height=100.0, y_position=0)
        layer = self.game_world.create_layer(pos=-15, relative_movement=(0.35, 0.2))
        layer.add_graphic('stars.png', tex_size=(5.0, 2.5), height=100.0, y_position=25.75)
        layer = self.game_world.create_layer(pos=-20, relative_movement=(0.45, 0.3))
        layer.add_graphic('stars.png', tex_size=(5.0, 2.5), height=100.0, y_position=32.1)
        layer.add_sprite('no_moon.png', (10.0, 5.0), (5.0, 14.0))

        self.fade_value = 1.0
        self.fade_blend = 'addictive'
        self.do_fade = True

        self.reset_scene = False

        self.game_world.optimise_geoms()
        self.game_world.optimise_back_geoms()

        self.game_world.bg_gradient = (hex_to_gl('#c34658'), hex_to_gl('#4b0047'))
        self.game_world.base_ambiant = (0.75, 0.75, 0.75)

        self.timeline.add_action(time=0.0, length=2.0, relative=time_now,
                                     repeat_callback=True,
                                     callback=self.timeline_cb_fadein_white)

        self.timeline.add_action(time=0.0, length=9.0, relative=time_now,
                                     repeat_callback=True,
                                     callback=self.cb_script_move_up)


        self.timeline.add_action(time=0.0, length=9.0, relative=time_now,
                                     repeat_callback=True,
                                     callback=self.cb_bg_fade)



        self.timeline.add_action(time=11.0, length=1.0, relative=time_now,
                                     repeat_callback=True,
                                     callback=self.cb_script_walk_right)

        self.timeline.add_action(time=12.5, length=0.1, wait=2.0, relative=time_now,
                                     repeat_callback=False, repeat_action=True,
                                     callback=self.cb_script_jump)

        self.timeline.add_action(time=12.5, length=6.0, relative=time_now,
                                     repeat_callback=True,
                                     callback=self.cb_script_create_jumpers)

        self.timeline.add_action(time=15.0, length=2.0, relative=time_now,
                                     repeat_callback=True,
                                     callback=self.cb_fin_fadein)

        self.timeline.add_action(time=22.0, length=2.0, relative=time_now,
                                     repeat_callback=True,
                                     callback=self.cb_fin_fadeout)
        self.timeline.add_action(time=24.0, relative=time_now, callback=self.cb_change_image)

        self.timeline.add_action(time=25.0, length=2.0, relative=time_now,
                                     repeat_callback=True,
                                     callback=self.cb_fin_fadein)

        self.timeline.add_action(time=31.0, length=2.0, relative=time_now,
                                     repeat_callback=True,
                                     callback=self.cb_fin_fadeout)
        self.timeline.add_action(time=33.0, relative=time_now, callback=self.cb_change_image)

        self.timeline.add_action(time=34.0, length=2.0, relative=time_now,
                                     repeat_callback=True,
                                     callback=self.cb_fin_fadein)

        self.timeline.add_action(time=40.0, length=2.0, relative=time_now,
                                     repeat_callback=True,
                                     callback=self.cb_fin_fadeout)
        self.timeline.add_action(time=42.0, relative=time_now, callback=self.cb_change_image)

        self.timeline.add_action(time=43.0, length=2.0, relative=time_now,
                                     repeat_callback=True,
                                     callback=self.cb_fin_fadein)



        self.timeline.add_action(time=15.0, length=25.0, relative=time_now,
                                 repeat_callback=True,
                                 callback=self.timeline_cb_fadein_black)


        tex = self.render.create_texture('sprites/UppetyBox/', repeats=('clamp', 'clamp'))
        self.box = gamelib.render.Sprite(self.render, tex, size=(0.5, 0.5), tile_repeats=(1.0, 1.0),
                                         blend='modulate')
        self.box.color = (0.8, 0.8, 0.8, 1.0)

        self.box1 = gamelib.render.Sprite(self.render, tex, size=(0.4, 0.4), tile_repeats=(1.0, 1.0),
                                         blend='modulate')
        self.box1.color = (0.7, 0.7, 0.7, 1.0)

        self.box2 = gamelib.render.Sprite(self.render, tex, size=(0.2, 0.3), tile_repeats=(1.0, 1.0),
                                         blend='modulate')
        self.box2.color = (0.6, 0.6, 0.6, 1.0)

        self.box3 = gamelib.render.Sprite(self.render, tex, size=(0.2, 0.2), tile_repeats=(1.0, 1.0),
                                         blend='modulate')
        self.box3.color = (0.5, 0.5, 0.5, 1.0)

        self.jumpers = []

        self.box.color = (1.0, 1.0, 1.0, 1.0)


        tex = self.render.create_texture('fin.png', repeats=('clamp', 'clamp'))
        self.fin = gamelib.render.Sprite(self.render, tex, size=(6.0, 3.0), tile_repeats=(1.0, 1.0),
                                         blend='modulate')

        tex = self.render.create_texture('cred1.png', repeats=('clamp', 'clamp'))
        self.cred1 = gamelib.render.Sprite(self.render, tex, size=(6.0, 6.0), tile_repeats=(1.0, 1.0),
                                         blend='modulate')

        tex = self.render.create_texture('cred2.png', repeats=('clamp', 'clamp'))
        self.cred2 = gamelib.render.Sprite(self.render, tex, size=(6.0, 6.0), tile_repeats=(1.0, 1.0),
                                         blend='modulate')

        tex = self.render.create_texture('cred3.png', repeats=('clamp', 'clamp'))
        self.cred3 = gamelib.render.Sprite(self.render, tex, size=(6.0, 6.0), tile_repeats=(1.0, 1.0),
                                         blend='modulate')


        self.fin.color = (1.0, 1.0, 1.0, 0.0)
        self.cred1.color = (1.0, 1.0, 1.0, 0.0)
        self.cred2.color = (1.0, 1.0, 1.0, 0.0)
        self.cred3.color = (1.0, 1.0, 1.0, 0.0)
        self.fade_color = (1.0, 1.0, 1.0, 0.0)
        self.current_image = 0

    def step(self):
        Scene.step(self)
        self.render.reset()
        self.render.set_screen_pos(0.0, 0.0)
        self.render.set_screen_zoom(1.0)
        self.render.set_screen()

        if self.current_image == 3:
            self.fin.position = (0.0, 0.0)
            self.fin.color = self.fade_color
            self.fin.draw()

        if self.current_image == 0:
            self.cred1.position = (0.0, 0.0)
            self.cred1.color = self.fade_color
            self.cred1.draw()

        if self.current_image == 1:
            self.cred2.position = (0.0, 0.0)
            self.cred2.color = self.fade_color
            self.cred2.draw()

        if self.current_image == 2:
            self.cred3.position = (0.0, 0.0)
            self.cred3.color = self.fade_color
            self.cred3.draw()

    def cb_script_move_up(self, progress):
        self.player.jump()

    def cb_script_walk_right(self, progress):
        self.player.go_right(slow=True)

    def cb_script_jump(self, progress):
        if self.timeline.current_time / 1000.0 < 37.0:
            self.player.jump()

    def cb_script_create_jumpers(self, progress):
        chance = 3
        dice = random.randrange(0, chance)
        if dice  == 0:
            dice = random.randrange(0, 4)
            sprite = self.box
            if dice == 1:
                sprite = self.box1
            if dice == 2:
                sprite = self.box2
            if dice == 3:
                sprite = self.box3



            bounds = self.render.get_screen_bounds()[0]
            box = yay_boxes(random.gauss(*bounds), 32.0, 33.0, sprite)
            self.game_world.add_misc(box)



    def cb_fin_fadein(self, progress):
        fade = cosine_interpolate(0.0, 1.0, progress)
        self.fade_color = (1.0, 1.0, 1.0, fade)

    def cb_fin_fadeout(self, progress):
        fade = cosine_interpolate(1.0, 0.0, progress)
        self.fade_color = (1.0, 1.0, 1.0, fade)

    def cb_change_image(self, progress):
        self.current_image += 1

    def timeline_cb_fadein_black(self, position):
        self.fade_value = cosine_interpolate(0.0, 1.0, position)
        self.fade_blend = 'subtractive'
        self.do_fade = True


    def get_fade(self, position, c1, c2):

        r = cosine_interpolate(c1[0], c2[0], position)
        g = cosine_interpolate(c1[1], c2[1], position)
        b = cosine_interpolate(c1[2], c2[2], position)

        return (r, g, b)


    def cb_bg_fade(self, position):
        #fade_colora1 =
        #fade_colorb1 =

        #fade_colora1 =
        #fade_colorb1 =

        ca = self.get_fade(position, self.fade_colora1, self.fade_colora2)
        cb = self.get_fade(position, self.fade_colorb1, self.fade_colorb2)

        self.game_world.bg_gradient = (ca, cb)

