##!/usr/bin/env python
## -*- coding: utf-8 -*-
##       level_end.py
##
##       Copyright 2008 Gordon Allott <gordallott@gmail.com>
##
##       This program is free software; you can redistribute it and/or modify
##       it under the terms of the GNU General Public License as published by
##       the Free Software Foundation; either version 3 of the License, or
##       (at your option) any later version.
##
##       This program is distributed in the hope that it will be useful,
##       but WITHOUT ANY WARRANTY; without even the implied warranty of
##       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##       GNU General Public License for more details.
##
##       You should have received a copy of the GNU General Public License
##       along with this program; if not, write to the Free Software
##       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
##       MA 02110-1301, USA.
##
##       #


#import pygame
#from pygame.locals import *

#import gamelib.data
#import gamelib.render
#import gamelib.world.gameworld
#from gamelib.world.gameworld import hex_to_gl
#from gamelib.world.props import *
#from gamelib.world.actors import *
#import gamelib.instance
#from gamelib.util import hex_to_gl

#from scene import *


#class level_end(Scene):

    #level_geom = 'levels/level_end.svg'

    #def __init__(self, *args, **kwargs):
        #Scene.__init__(self, *args, **kwargs)
        #self.stop_scene = False

        #self.game_world = gamelib.world.gameworld.world(self.render)
        #self.game_world.bg_gradient = (hex_to_gl('#000000'), hex_to_gl('#444444'))

        #gamelib.instance.instance.audio.play_music('Infados.ogg')

        ## add an actor
        #self.player = self.game_world.add_actor(actor_object=Player, position=(0.0, 3.0))


        #self.input.add_key(K_a, self.cb_walk, repeating=True)
        #self.input.add_key(K_d, self.cb_walk, repeating=True)
        #self.input.add_key(K_w, self.cb_jump, repeating=True)

        #self.input.add_key(K_BACKSPACE, self.cb_skip)


        #self.build_geoms(self.game_world, 'levels/level_end.svg')


        ##layer = self.game_world.create_layer(pos=-10, relative_movement=(0.5, 0.8))
        ##layer.add_graphic('bg1.png', tex_size=(10.0, 5.0), height=5.0, y_position=0.0)

        ##layer = self.game_world.create_layer(pos=-5, relative_movement=(0.25, 0.8))
        ##layer.add_graphic('clouds.png', tex_size=(10.0, 10.0), height=20.0, y_position=8)

        ### add a light i guess
        ##light = self.game_world.add_light()

        #self.game_world.bg_gradient = (hex_to_gl('#623166'), hex_to_gl('#36274b'))





    #def step(self):
        #pos = self.player.get_position()
        #self.render.set_screen_pos(-pos[0], -pos[1])
        #self.render.set_screen_zoom(1.5)
        #self.render.set_screen()

        #self.game_world.step()
        #self.game_world.draw()



        #self.render.reset()

    #def cb_skip(self, key):
        #self.stop_scene = True



    #def cb_walk(self, key):

        #if key == K_a:
            #self.player.go_left()
        #if key == K_d:
            #self.player.go_right()

    #def cb_jump(self, key):
        #self.player.jump()

#!/usr/bin/env python
# -*- coding: utf-8 -*-
#       level_one.py
#
#       Copyright 2008 Gordon Allott <gordallott@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 3 of the License, or
#       (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.
#
#


import pygame
from pygame.locals import *

import gamelib.data
import gamelib.render
import gamelib.world.gameworld
from gamelib.world.gameworld import hex_to_gl
from gamelib.world.props import *
from gamelib.world.actors import *
import gamelib.instance
from gamelib.timeline import Timeline, time_now, time_start
from gamelib.util import cosine_interpolate, linear_interpolate
from scene import *
from OpenGL.GL import *


class level_end(Scene):

    level_geom = 'levels/level_end.svg'

    def __init__(self, *args, **kwargs):
        Scene.__init__(self, *args, **kwargs)
        self.timeline = Timeline()
        gamelib.instance.instance.audio.play_music('DD Groove.ogg')
        self.left_trigger = False
        self.right_trigger = False

        self.start_level()



    def start_level(self):
        self.fade_value = 0.0
        self.fade_blend = 'addictive'
        self.do_fade = False
        gamelib.instance.instance.audio.stop_all()

        self.do_reset = False

        self.stop_scene = False
        self.game_world = gamelib.world.gameworld.world(self.render)


        # add an actor
        #self.player = self.game_world.add_actor(actor_object=Player, position=(26.0, 16 + 1.27*0.5))
        self.player = self.game_world.add_actor(actor_object=Player, position=(0.0, 0 + 1.27*0.5))

        #self.input.add_key(K_a, self.cb_walk, repeating=True)
        #self.input.add_key(K_d, self.cb_walk, repeating=True)
        #self.input.add_key(K_w, self.cb_jump, repeating=True)
        #self.input.add_key(K_BACKSPACE, self.cb_skip)

        self.set_keys()

        self.build_geoms(self.game_world, 'levels/level_end.svg')

        layer = self.game_world.create_layer(pos=-5, relative_movement=(0.25, 0.1))
        layer.add_graphic('stars.png', tex_size=(5.0, 2.5), height=100.0, y_position=0, movement=(0.02, 0.0))
        layer = self.game_world.create_layer(pos=-15, relative_movement=(0.35, 0.2))
        layer.add_graphic('stars.png', tex_size=(5.0, 2.5), height=100.0, y_position=25.75)
        layer = self.game_world.create_layer(pos=-20, relative_movement=(0.45, 0.3))
        layer.add_graphic('stars.png', tex_size=(5.0, 2.5), height=100.0, y_position=32.1,  movement=(0.01, 0.0))
        layer.add_sprite('no_moon.png', (10.0, 5.0), (5.0, 20.0))

        self.fade_value = 1.0
        self.fade_blend = 'addictive'
        self.do_fade = True

        self.reset_scene = False

        self.game_world.optimise_geoms()
        self.game_world.optimise_back_geoms()
        self.game_world.optimise_lights()

        self.game_world.bg_gradient = (hex_to_gl('#c34658'), hex_to_gl('#4b0047'))
        self.timeline.add_action(time=0.0, length=2.0, relative=time_now,
                                     repeat_callback=True,
                                     callback=self.timeline_cb_fadein_white)

        #find our actors

        self.left_actor = findid(self.game_world.actors, 'auto_switch_1')
        self.right_actor = findid(self.game_world.actors, 'auto_switch_2')

        if self.left_trigger:
            self.left_actor.cb_collide(self.left_actor, self.player, {})

        if self.right_trigger:
            self.right_actor.cb_collide(self.right_actor, self.player, {})


    def step(self):
        Scene.step(self)
        if self.left_actor.switch_on:
            self.left_trigger = True

        if self.right_actor.switch_on:
            self.right_trigger = True
