#!/usr/bin/env python
# -*- coding: utf-8 -*-
#       scene_one.py
#
#       Copyright 2008 Gordon Allott <gordallott@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 3 of the License, or
#       (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.
#
#       #
import pygame
from pygame.locals import *

import gamelib.data
import gamelib.render
import gamelib.world.gameworld
from gamelib.world.props import *

from scene import *
#from gamelib.RenderLib import Texture, Sprite

# THIS IS A TEST SCENE - DON'T BOTHER TRYING TO MAKE THIS NICE!
# MAKE A NEW SCENE AND ADD IT TO MAIN.PY FOR PROPER GAME

class scene_one(Scene):

    def __init__(self, *args, **kwargs):
        Scene.__init__(self, *args, **kwargs)

        self.game_world = gamelib.world.gameworld.world(self.render)


        #create a prop_small_box
        #self.game_world.add_prop(prop_object=prop_small_box, position=( 0.0, 5.0))
        #self.game_world.add_prop(prop_object=prop_small_box, position=( 2.0, 5.0))
        #self.game_world.add_prop(prop_object=prop_small_box, position=(-2.0, 5.0))
        #self.game_world.add_prop(prop_object=prop_small_box, position=( 4.0, 5.0))
        #self.game_world.add_prop(prop_object=prop_small_box, position=(-4.0, 5.0))

        # add a small geometry
        self.game_world.add_geom(size=(100.0, 5.0), position=(0.0, -2.5), graphic_filename='ground.png',
                 tiles=(20.0, 1.0))

        #self.game_world.add_geom(size=(10.0, 2.0), position=(0.0, 1.0), graphic_filename='small_box.png',
                 #tiles=(10.0, 2.0))

        #self.game_world.add_geom(size=(1.0, 20.0),
                                 #position=(10.0, 12.0), graphic_filename='small_box.png',
                                 #tiles=(1.0, 2.0))

        # add an actor
        self.player = self.game_world.add_actor(actor_object=Player, position=(-2.0, 10.0))

        self.input.add_key(K_a, self.cb_walk, repeating=True)
        self.input.add_key(K_d, self.cb_walk, repeating=True)
        self.input.add_key(K_w, self.cb_jump, repeating=True)

        tex = self.render.create_texture('bg_hills.png')

        # add a landscapes
        self.game_world.add_landscape('bg_hills.png', clamp_to=('center', 'bottom'), top=1.0, bottom=0.0,
                        repeats=('repeat', 'clamp'), movement=(1.0, 1.0))

        self.build_geoms(self.game_world, 'levels/test2.svg')


    def step(self):
        pos = self.player.get_position()
        self.render.set_screen_pos(-pos[0], -pos[1])
        self.render.set_screen()

        self.game_world.step()

        self.game_world.draw()

        self.render.reset()




    def cb_walk(self, key):

        if key == K_a:
            self.player.go_left()
        if key == K_d:
            self.player.go_right()

    def cb_jump(self, key):
        self.player.jump()
