#!/usr/bin/env python
# -*- coding: utf-8 -*-
#       util.py
#
#       Copyright 2008 Gordon Allott <gordallott@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 3 of the License, or
#       (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.
#
#       #
import random
import math

def make_id(store=None):

    if not store:
        return random.randrange(0, 2**16)

    id = 0
    while True:
        if not store.has_key(id):
            break

        else:
            id = random.randrange(0, 2**16)

    return id


def hex_to_gl(colorhex):
    colorhex = colorhex.replace('#', '')

    red = colorhex[0] + colorhex[1]
    green = colorhex[2] + colorhex[3]
    blue = colorhex[4] + colorhex[5]

    color = (float(int(red, 16)) / 255.0,
             float(int(green, 16)) / 255.0,
             float(int(blue, 16)) / 255.0,
            )

    return color


#function Cosine_Interpolate(a, b, x)
    #ft = x * 3.1415927
    #f = (1 - cos(ft)) * .5

    #return  a*(1-f) + b*f

def cosine_interpolate(a, b, x):
    ft = x * math.pi
    f = (1.0 - math.cos(ft)) * 0.5
    return a * (1.0 - f) + b * f

  #function Linear_Interpolate(a, b, x)
    #return  a*(1-x) + b*x

def linear_interpolate(a, b, x):
    return a * (1.0 - x) + b * x
